import React, {FC, useEffect, useState} from "react";
import Cookies from "js-cookie";
import {fetchUser,getBaseInfoByWxId} from "../api";
import {Spin,Form, Input, Button, Select,Radio,Tag} from "antd";
import { SearchOutlined } from '@ant-design/icons';
import './../css/home.css'
import jt from './../assets/images/jt.png'
import {jsSdk} from "../index"
import {Link} from "react-router-dom";
const {TextArea} = Input

const Home: FC = () => {
  const [loading, setLoading] = useState<boolean>(false);
  const [user, setUser] = useState<UserResponse>();
  const [customInfoEdit,setCustomInfoEdit] = useState<boolean>(false);
  const [labelValue,setlabelValue]= useState<string>('');
  const [customInfo,setCustomInfo] = useState<any>({
    realName:'whh',
    account_level :'一级',
    sexy:1,
    idType:'1',
    idNumber:'1233',
    mobileNumber: '333',
    point: '112',
    corp: '1',
    position: '2',
    lastTime: '333',
    note: '33',
    area: '3',
    addr: '3',
    email: '3',
    gyId: '2',
    keywords: '2',

  });
  const [labels,setLabels] = useState<any>([{id:2,labelName:'跑步',color:'blue'},{id:2,labelName:'教育',color:'green'}]);
  const [idTypeOpt] = useState<any>([
    {
      value: '0',
      label: '身份证',
    },
    {
      value: '1',
      label: '护照',
    },
    {
      value: '2',
      label: '港澳回乡证',
    },
    {
      value: '3',
      label: '台胞证',
    },
    {
      value: '4',
      label: '其它',
    },
  ])
  const { Option } = Select;

const layout = {
  labelCol: { span: 8 },
  wrapperCol: { span: 16 },
};
const tailLayout = {
  wrapperCol: { offset: 8, span: 16 },
};
  const [form] = Form.useForm();
  const onGenderChange = (value: string) => {
    switch (value) {
      case 'male':
        form.setFieldsValue({ note: 'Hi, man!' });
        return;
      case 'female':
        form.setFieldsValue({ note: 'Hi, lady!' });
        return;
      case 'other':
        form.setFieldsValue({ note: 'Hi there!' });
    }
  };

  const onFinish = (values: any) => {
    console.log(values);
  };

  const onReset = () => {
    form.resetFields();
  };

  const onFill = () => {
    console.log(customInfo)
    debugger
  };
  const testClick=(): void=>{
    console.log('aaaa')
    setCustomInfoEdit(!customInfoEdit)
  }
  const labelAdd=(e:any)=>{
    // console.log(e.target.value)
    setlabelValue(e.target.value)
    console.log(labelValue)
    
  }
  // 获取当前外部联系人信息
  const getUserInfo = async () => {
    // setLoading(true);
    // const userId = Cookies.get('userId')
    const userInfo:any = Cookies.get('userInfo')
    // const userInfo = await fetchUser(userId || '')
    console.log(userInfo)
    // setUser(JSON.parse(userInfo))
    // setLoading(false)
  }
  const getExternalUserInfo = async () => {
    const res = await jsSdk.invoke<{ userId?: string }>('getCurExternalContact', {})
    // alert(JSON.stringify(res))
    debugger
    if (!res || !res.userId) return
    let data:any = {wxId:res.userId}
    const userInfo = await getBaseInfoByWxId(data)
    console.log(userInfo.data.userInfo)
    debugger
    if(userInfo.data.userInfo){
      setCustomInfo({...userInfo.data.userInfo})
    }
    console.log('外部联系人 ID', res.userId);
    debugger


  }

  useEffect(() => {
    getUserInfo();
    getExternalUserInfo()
  }, [])
  // const { getFieldsValue,getFieldDecorator } = this.props.form;

  return (
    <Spin spinning={loading}>
      <div className="flex spaceBetween mg20">
        <span className='wordKb'>用户看板</span>
        <Link to="/findCustom"><Button type="primary" icon={<SearchOutlined />}>查找客户</Button></Link>
        
      </div>
      <div className="custom mg20">
        <div className="flex spaceBetween customitem">
          <p className='word'>客户信息</p>
          <img src={jt} alt="" className="more" onClick={testClick}/>
        </div>
        {/* <div className="flex">
          <span>{customInfo.realName || '-' }</span>
          <div>{ customInfo.account_level }</div>
        </div> */}
        <div className="">
        {customInfoEdit?(
              <div  className="labelAdd">
                <div className='greyb'>
                    {labels.map((item:any)=> <Tag closable className={"tags" +" "+item.color}>{item.labelName}</Tag>)}
                </div>
                <div className="flex mgt20">
                  <span>添加标签：</span>
                  {/* <TextArea style={{width: '100%', marginBottom: 8}} value={labelValue} onChange={e => labelAdd(e.target.value)}/> */}
                  <input type="text" className="greyInt" defaultValue={labelValue} onChange={labelAdd}/>
                </div>
                <div className="flex flex-warp mgt20">
                  <span>添加颜色：</span>
                  <div className="line blue">
                    <div className="innerline"></div>
                  </div>
                  <div className="line green"><div className="innerline innerGreen"></div></div>
                  <div className="line orange"><div className="innerline innerOrgane"></div></div>
                  <div className="line red"><div className="innerline innerRed"></div></div>
                  <div className="line greyl"><div className="innerline innerGrey"></div></div>
                </div>
              </div>

            ): ('')}
          <div className="inner flex spaceBetween">
            <Form {...layout} name="control-hooks" onFinish={onFinish} initialValues={customInfo}>
            {!customInfoEdit?(<div className="flex spaceBetween showt">
              <span>{customInfo.realName || '-' }</span>
              <div className='grad'>{ customInfo.account_level || '重要客户' }</div>
            </div>): ('')}
            {customInfoEdit?(
              <Form.Item name="realName" label="客户名称" >
                  <Input  placeholder="请输入客户名称" value={customInfo.realName}/>
                </Form.Item>
            ): ('')}
              
              {!customInfoEdit?(<div className="flex flex-wrap">
                  <div className="flex mgr20">
                      <span className='greyWord'>性别：</span>
                      {customInfo.sexy===1?(<div><span className="radio-wight radio-text radio-text-m"> ♂</span> <span className="radio-text radio-text-m"> 男</span></div>)
                      :(
                      <div><span className="radio-wight radio-text radio-text-w"> ♂</span> <span className="radio-text radio-text-w"> 女</span></div>
                      )}
                  </div>
                  <div className="flex mgr20">
                      <span className='greyWord'>手机号：</span>
                      <span>{customInfo.mobileNumber}</span>
                  </div>
                  <div className="flex">
                      <span className='greyWord'>积分：</span>
                      <span>{customInfo.point}</span>
                  </div>
                </div>):('')}

                {customInfoEdit?( <Form.Item name="sexy" label="性别" >
              <Radio.Group value={customInfo.sexy}>
                  <Radio value={1}><span className="radio-wight radio-text radio-text-m"> ♂</span> <span className="radio-text radio-text-m"> 男</span></Radio>
                  <Radio value={2}><span className="radio-wight radio-text radio-text-w"> ♀</span> <span className="radio-text radio-text-w"> 女</span></Radio>
                </Radio.Group>
              </Form.Item>)
              :('')}
              {customInfoEdit?(<Form.Item name="idType" label="证件类型" >
                <Select
                  placeholder="请选择证件类型"
                  value={customInfo.idType}
                  allowClear
                >
                  {idTypeOpt.map((item:any) =>  <Option value={item.value}>{item.label}</Option>)}
                </Select>
              </Form.Item>):('')}
              {customInfoEdit?(<Form.Item name="idNumber" label="证件号" >
              <Input  placeholder="请输入证件号" value={customInfo.idNumber}/>
              </Form.Item>):('')}
              {customInfoEdit?(<Form.Item name="mobileNumber" label="手机号" >
                {customInfo.mobileNumber}
              </Form.Item>):('')}
              {customInfoEdit?(<Form.Item name="point" label="积分" >
                {customInfo.point}
              </Form.Item>):('')}
              <div className="flex">
                  <span className='greyWord'>公司：</span>
                  <span>{customInfo.corp}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>职务：</span>
                  <span>{customInfo.position}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>最后跟进：</span>
                  <span>{customInfo.corp}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>备注：</span>
                  <span>{customInfo.keywords}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>地区：</span>
                  <span>{customInfo.area}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>收货地址：</span>
                  <span>{customInfo.addr}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>Email：</span>
                  <span>{customInfo.email}</span>
              </div>
              <div className="flex">
                  <span className='greyWord'>戈友ID：</span>
                  <span>{customInfo.gyId}</span>
              </div>
              {!customInfoEdit?(
              <div className="flex">
                  <span className='greyWord'>证件类型：</span>
                  <span>{customInfo.idType}</span>
              </div>):('')}
              {!customInfoEdit?(<div className="flex">
                  <span className='greyWord'>证件号：</span>
                  <span>{customInfo.idNumber}</span>
              </div>):('')}
              {!customInfoEdit?(<div className="labels grey">
                <div className="greyWord">客户标签</div>
                <div className="flex flex-warp ">
                  {labels.map((item:any,idx:number)=><div className={"labelStyle" + " " +"color"+idx }>{item.labelName}</div>)}
                </div>
                
              </div>):('')}
              
              {/* <Form.Item {...tailLayout}>
                <Button type="primary" htmlType="submit">
                  Submit
                </Button>
                <Button htmlType="button" onClick={onReset}>
                  Reset
                </Button>
                <Button type="link" htmlType="button" onClick={onFill}>
                  Fill form
                </Button>
              </Form.Item> */}
            </Form>
          </div>
        </div>
      </div>
    </Spin>
  )
}

export default Home;
